## ESourceCredentialsProviderImpl ESourceCredentialsProviderImpl |

## Functions

struct _ESourceCredentialsProvider * | e_source_credentials_provider_impl_get_provider ()
gboolean | e_source_credentials_provider_impl_can_process ()
gboolean | e_source_credentials_provider_impl_can_store ()
gboolean | e_source_credentials_provider_impl_can_prompt ()
gboolean | e_source_credentials_provider_impl_lookup_sync ()
gboolean | e_source_credentials_provider_impl_store_sync ()
gboolean | e_source_credentials_provider_impl_delete_sync ()

## Types and Values

struct | ESourceCredentialsProviderImpl

## Object Hierarchy

        GObject
        ╰── EExtension
            ╰── ESourceCredentialsProviderImpl
                ├── ESourceCredentialsProviderImplOAuth2
                ╰── ESourceCredentialsProviderImplPassword

## Description

## Functions

### e_source_credentials_provider_impl_get_provider ()

    struct _ESourceCredentialsProvider *
    e_source_credentials_provider_impl_get_provider
                                   (ESourceCredentialsProviderImpl *provider_impl);

Returns an ESourceCredentialsProvider with which the `provider_impl` is associated.

#### Parameters

provider_impl | an ESourceCredentialsProviderImpl |

#### Returns

(transfer none) : an ESourceCredentialsProvider

Since: 3.16

### e_source_credentials_provider_impl_can_process ()

    gboolean
    e_source_credentials_provider_impl_can_process
                                   (ESourceCredentialsProviderImpl *provider_impl,
                                    ESource *source);

Returns whether the `provider_impl` can process credentials for the `source` .

#### Parameters

provider_impl | an ESourceCredentialsProviderImpl |
source | an ESource |

#### Returns

Whether the `provider_impl` can process credentials for the `source` .

Since: 3.16

### e_source_credentials_provider_impl_can_store ()

    gboolean
    e_source_credentials_provider_impl_can_store
                                   (ESourceCredentialsProviderImpl *provider_impl);

Returns whether the `provider_impl` can store credentials.

#### Parameters

provider_impl | an ESourceCredentialsProviderImpl |

#### Returns

Whether the `provider_impl` can store credentials.

Since: 3.16

### e_source_credentials_provider_impl_can_prompt ()

    gboolean
    e_source_credentials_provider_impl_can_prompt
                                   (ESourceCredentialsProviderImpl *provider_impl);

Returns whether credential prompt can be done for the `provider_impl` .

#### Parameters

provider_impl | an ESourceCredentialsProviderImpl |

#### Returns

Whether credential prompt can be done for the `provider_impl` .

Since: 3.16

### e_source_credentials_provider_impl_lookup_sync ()

    gboolean
    e_source_credentials_provider_impl_lookup_sync
                                   (ESourceCredentialsProviderImpl *provider_impl,
                                    ESource *source,
                                    GCancellable *cancellable,
                                    ENamedParameters **out_credentials,
                                    GError **error);

Asks `provider_impl` to lookup for stored credentials for `source` . The `out_credentials` is populated with them. If the result is not `NULL`, then it should be freed with `e_named_parameters_free()` when no longer needed.

Default implementation returns `FALSE` and sets G_IO_ERROR_NOT_SUPPORTED error.

If an error occurs, the function sets `error` and returns `FALSE`.

#### Parameters

provider_impl | an ESourceCredentialsProviderImpl |
source | an ESource |
cancellable | optional GCancellable object, or `NULL` |
out_credentials | an ENamedParameters to be set with stored credentials. | [out]
error | return location for a GError, or `NULL` |

#### Returns

`TRUE` on success, `FALSE` on error

Since: 3.16

### e_source_credentials_provider_impl_store_sync ()

    gboolean
    e_source_credentials_provider_impl_store_sync
                                   (ESourceCredentialsProviderImpl *provider_impl,
                                    ESource *source,
                                    const ENamedParameters *credentials,
                                    gboolean permanently,
                                    GCancellable *cancellable,
                                    GError **error);

Asks `provider_impl` to store `credentials` for `source` .

Default implementation returns `FALSE` and sets G_IO_ERROR_NOT_SUPPORTED error.

If an error occurs, the function sets `error` and returns `FALSE`.

#### Parameters

provider_impl | an ESourceCredentialsProviderImpl |
source | an ESource |
credentials | an ENamedParameters containing credentials to store |
permanently | whether to store credentials permanently, or for the current session only |
cancellable | optional GCancellable object, or `NULL` |
error | return location for a GError, or `NULL` |

#### Returns

`TRUE` on success, `FALSE` on error

Since: 3.16

### e_source_credentials_provider_impl_delete_sync ()

    gboolean
    e_source_credentials_provider_impl_delete_sync
                                   (ESourceCredentialsProviderImpl *provider_impl,
                                    ESource *source,
                                    GCancellable *cancellable,
                                    GError **error);

Asks `provider_impl` to delete any stored credentials for `source` .

Default implementation returns `FALSE` and sets G_IO_ERROR_NOT_SUPPORTED error.

If an error occurs, the function sets `error` and returns `FALSE`.

#### Parameters

provider_impl | an ESourceCredentialsProviderImpl |
source | an ESource |
cancellable | optional GCancellable object, or `NULL` |
error | return location for a GError, or `NULL` |

#### Returns

`TRUE` on success, `FALSE` on error

Since: 3.16

## Types and Values

### struct ESourceCredentialsProviderImpl

    struct ESourceCredentialsProviderImpl;

Credentials provider implementation base structure. The descendants implement the virtual methods. The descendants are automatically registered into an ESourceCredentialsProvider.

Since: 3.16